
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

format PE GUI
entry Start

section '.text' executable code data readable writeable

include 'windows/Use32.inc'
include 'windows/threadfunctions.inc'
include 'windows/modulefunctions.inc'
include 'windows/memfunctions.inc'
include 'windows/exceptions.inc'
include 'windows/user.inc'
include 'include/base.asm'
include 'windows/savedatatodisk.inc'
include 'windows/timedate.inc'	     ;HTTP protocol
include 'windows/service_windows_nt.inc'

data import
library kernel32,'KERNEL32.DLL',\
	advapi32,'ADVAPI32.DLL',\
	 user32,'USER32.DLL'

include 'API\KERNEL32.INC'
include 'API\USER32.INC'
include 'windows\adapted_ADVAPI32.INC'
end data

data resource
  directory RT_VERSION,versions,\
	    24,manifest

  resource versions,\
	   1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	      'FileDescription',"TV's server x86",\
	      'LegalCopyright',<'Tycho Veltmeijer Copyright ',0A9h,' 2014.'>,\
	      'FileVersion',"3.00.00",\
	      'ProductVersion',"3.00.00",\
	      'OriginalFilename','base32_win.exe'

  resource manifest,\
	   1,LANG_NEUTRAL,mymanifest

  resdata mymanifest
    db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0" xmlns:asmv3="urn:schemas-microsoft-com:asm.v3"><assemblyIdentity name="Tycho Veltmeijer" processorArchitecture="x86" version="3.0.0.0" type="win32"/><description>TV',0x27,'s server x86</description><trustInfo xmlns="urn:schemas-microsoft-com:asm.v3"><security><requestedPrivileges><requestedExecutionLevel level="requireAdministrator" uiAccess="false"/></requestedPrivileges></security></trustInfo></assembly>'
  endres
end data