
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will call GetListItem and return an new pointer created by CreateMemLocation
;input 1: list
;      2: rowId
;      3: itemId

;output EAX:pointer to item (or just the item if integer)
;------------------------------------------------------------------------------
if used GetListItemPointer
GetListItemPointer:
call denter

mov pebx,pdword [pebp+psize*2] ;list
mov pedx,pdword [pebp+psize*3] ;rowId
mov pedi,pdword [pebp+psize*4] ;itemId

push pedi	;itemId
push pedx	;rowId
push pebx	;list
call [GetListItemSize]
mov ecx,eax
push peax ;save item size
jecxz justADwordOrQword

;get big enough size memory location
push peax
call GetMemLocation
mov pesi,peax

push pesp	;&len
push pesi	;data
jmp getPointerGetListItemPointer

justADwordOrQword:
;empty 1 pointer on stack for return value
xor eax,eax
xchg pdword [pesp],peax

mov pesi,pesp ;(R/E)SI = pointer to free pointer on stack
push peax     ;push item size
push pesp     ;&len
push pesi     ;data

getPointerGetListItemPointer:
push pedi	;itemId
push pedx	;rowId
push pebx	;list
call [GetListItem]

mov peax,pesi
test ecx,ecx
jnz endGetListItemPointer

pop peax ;pop &len
pop peax ;pop the return value

endGetListItemPointer:
call dleave
ret psize*3
end if