;------------------------------------------------------------------------------
;This function will initialize the ClientSession (if TCP) and handle the connection (if HTTP)
;------------------------------------------------------------------------------
HandleConnection:
StartProc 2 ;Set arguments on stack
call denter

mov pedx,pdword [pebp+psize*2]	;psess
mov pecx,pdword [pebp+psize*3]	;sess

xor eax,eax ;return value


;find the data member of this protocol
push pdword [pecx+8]	   ;ProtocolData structure of ClientSession structure
push pedx		   ;psess
call [FindProtocolDataStruct]
mov dword [peax+psize*2],0 ;Nothing send yet, set this value on zero

;call the next HandleConnection function from the other protocols
push pecx	;sess
push pedx	;psess
call [CallNextHandleConnection]

;-------------------------------------------------------------------
;-Send string  "______________________________________________________________________________"
;-------------------------------------------------------------------
push manipulerenBend -manipulerenB

push pesp					    ;&len
if used isLinux
  lea peax,dword [manipulerenB]
  push peax					    ;buff
else
  push manipulerenB				   ;buff
end if
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pecx					    ;sess
push pedx					    ;psess
call [SendData]

add pesp,psize

endHandleConnection:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)

;------------------------------------------------------------------------------
;This function will manipulate the received data
;------------------------------------------------------------------------------
RecvData_Man:
StartProc 6 ;Set arguments on stack
jmp [RecvData]

;------------------------------------------------------------------------------
;This function will manipulate the send data
;------------------------------------------------------------------------------
SendData_Man:
StartProc 6 ;Set arguments on stack
call denter

xor eax,eax ;return value

;check if the psess value is psess_man
mov pedx,pdword [pebp+(psize*3)] ;sess
mov pecx,pdword [pebp+(psize*2)] ;psess
cmp [psess_man],pecx
jne endSendData_Man

;find the data member of this protocol
push pdword [pedx+8]	   ;ProtocolData structure of ClientSession structure
push pecx		   ;psess
call [FindProtocolDataStruct]
lea pebx,dword [peax+psize*2] ;EBX = Pointer to first item on ProtocolData Structure
mov esi,dword [pebx] ;ESI = first value of the ProtocolData Structure

;-------------------------------------------------------------------
;-Send string "Deze verbindin is gemanipuleerd, de Laborer protocol wilde het volgende naar je sturen:"
;-------------------------------------------------------------------
test esi,esi
jnz notFirstSend

push manipulerenAend -manipulerenA

push pesp					    ;&len
if used isLinux
  lea peax,dword [manipulerenA]
  push peax					    ;buff
else
  push manipulerenA				    ;buff
end if
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pedx					    ;sess
push pecx					    ;psess
call [SendData]

add pesp,psize

push psize ;len value
mov pedi,pesp

push 0	      ;return pointer for list
mov peax,pesp

push GDPD_IS_LIST or GDPD_NAME_IS_INTEGER ;flags
push pedi	       ;len
push peax	       ;data
push 878	       ;name
push pedx	       ;sess
push 0		       ;lsess
push pecx	       ;psess
call [GetPluginData]

pop pedi ;pointer to list
add pesp,psize ;remove size

push pesi
xor pesi,pesi

loopFoundItems:
  ;push 13 ;integer to find
  ;mov peax,pesp


  push pesi  ;startFromRow
  push 0     ;flags
  push psize ;ignored :o
  push regel1  ;item to find
  push 0     ;columnId
  push pedi  ;list*
  call [FindListItem]
  test peax,peax
  jz endloopFoundItems

  mov pesi,peax

  ;add pesp,psize

  push 100

  push pesp		      ;len
  push option_6_displayname   ;data
  push 0		      ;itemId
  push peax		      ;rowId
  push pedi		      ;list
  call [GetListItem]

  add pesp,psize

  push option_6_displayname
  call strlen

  push peax

  push pesp					      ;&len
  push option_6_displayname			      ;buff
  push DEFAULT_SENDTIMEOUT			      ;timeout
  push pdword [pebp+psize*4]			      ;flags
  push pedx					      ;sess
  push pecx					      ;psess
  call [SendData]
  add pesp,psize

  ;push 0
  ;push option_6_displayname
  ;call message
jmp loopFoundItems

endloopFoundItems:
pop pesi

mov esi,1 ;set the value on 'send'

notFirstSend:
;-------------------------------------------------------------------
;-Send data of the laborer protocol
;-------------------------------------------------------------------
push pdword [pebp+psize*7]			    ;&len
push pdword [pebp+psize*6]			    ;buff=
push pdword [pebp+psize*5]			    ;timeout
push pdword [pebp+psize*4]			    ;flags
push pedx					    ;sess
push pecx					    ;psess
call [SendData]

mov dword [pebx],esi ;set the value of the ProtocolData structure


endSendData_Man:
call dleave
EndProc 4
ret (FunctionReturnFactor*5)
