include '../include/function.inc'
include '../include/flags.inc'
include '../include_plugin_general/short_functions.inc'
include 'include_plugin_test3/plugin_handle_connection.inc'

EXTRASIZE_LISTEN_AND_CLIENT_STRUCT equ psize*2 ;We want 2 pointers in the Listen/Client session

sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols


include 'include_plugin_test3/plugin_bind.inc'
include '../include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

push 27   ;dd
push 03   ;mm
push 1991 ;yyyy
call [FormatDate]
mov [defaultDate],peax

push 1	 ;ms
push 27  ;ss
push 20  ;mm
push 7	 ;hh
call [FormatTime]
mov [defaultTime],peax


if used is32
  push myDATETIME
end if
push 27  ;ss
push 20  ;mm
push 7	 ;hh
push 27   ;dd
push 03   ;mm
push 1991 ;yyyy
call [FormatDateTime]
if used is64
  mov [defaultDateTime],rax
  mov [defaultTime2],rax
  mov [defaultTime3],rax
end if

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)]
mov peax,pdword[peax+(psize*1)]

;Do we init manipulator?
if used isLinux
  lea pecx,dword [manipulator]
  push pecx
else
  push manipulator
end if
push peax
call strcmp
test eax,eax
jnz endStartProtocol

;init manipulator
push V_TV_SERVER_1 ;version
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT ;extraSize
push 0 ;pSign
push PT_MANIPULATOR  ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

push httpControlPanelOptions  ;cpo
push pdword [pebp+(psize*2)] ;psess
call [SetControlPanelOptions]

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_man],pecx
jmp endStartProtocol

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)