
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

format PE GUI 4.0 DLL

section '.text' code data readable writeable executable
db "TV's server 3.00"
dd __asm_exchange_tables

include 'windows/Use32.inc'
include 'include/flags.inc'
include 'windows/memfunctions.inc'
include 'include_tvs_server_plugin_tcp_protocol/tvs_server_plugin_tcp_protocol_base.asm'
include 'windows/threadfunctions.inc'
;include 'windows/user.inc'
include 'windows/sockets.inc'
include 'include_tvs_server_plugin_tcp_protocol/plugin_export_list.inc'
include 'include_tvs_server_plugin_tcp_protocol/readable_writeable_data.inc'

;data export
;  export 'tvs_server_plugin_tcp_protocol_x86.DLL',\
;         __asm_exchange_tables,'__asm_exchange_tables'
;end data

data import
library kernel32,'KERNEL32.DLL',\
	 wsock32,'WS2_32.DLL'

include 'API\KERNEL32.INC'
include 'windows/adapted_WSOCK32.INC'
end data

data resource
  directory RT_VERSION,versions

  resource versions,\
	   1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	      'FileDescription',"TCP/IP plugin for TV's server x86",\
	      'LegalCopyright',<'Tycho Veltmeijer Copyright ',0A9h,' 2014.'>,\
	      'FileVersion',"3.00.00",\
	      'ProductVersion',"3.00.00"
end data

section '.reloc' fixups data readable discardable