
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

format PE64 GUI 4.0 DLL
entry main

section '.text' code data readable writeable executable
db "TV's server 3.00"
dq __asm_exchange_tables

include 'windows/Use64.inc'
include 'include/flags.inc'
include 'windows/memfunctions.inc'
include 'windows/register.inc'
include 'include_tvs_server_plugin_http/tvs_server_plugin_http_base.asm'
include 'windows/threadfunctions.inc'
include 'windows/fileFunctions.inc'
include 'windows/user.inc'
include 'windows/launch_cgi.inc'
include 'windows/modulefunctions.inc'
include 'include_tvs_server_plugin_http/plugin_export_list.inc'
include 'include_tvs_server_plugin_http/readable_writeable_data.inc'

;data export
;  export 'tvs_server_plugin_http_x64.DLL',\
;         __asm_exchange_tables,'__asm_exchange_tables'

data import
library kernel32,'KERNEL32.DLL',\
        user32,'USER32.DLL',\
         tvHttpProtocol,'tvs_server_http_protocol_x64.DLL'

include 'windows/adapted_KERNEL32.INC'
include 'api/user32.INC'

;import tvHttpProtocol,\
;         __asm_exchange_tables_HTTP_PROTOCOL,'__asm_exchange_tables',\
;         RecvAndParseHTTP, 'RecvAndParseHTTP',\
;         FreeHTTPSession, 'FreeHTTPSession',\
;         SendHTTPHeader, 'SendHTTPHeader',\
;         ConvertEscapedCharactersToBytes, 'ConvertEscapedCharactersToBytes',\
;         GetCollectionItem,'GetCollectionItem',\
;         EscapeAndSendValue,'EscapeAndSendValue',\
;         DeleteDoubleSlashesInUrl,'DeleteDoubleSlashesInUrl',\
;         DecodeURL,'DecodeURL',\
;         SendFile,'SendFile',\
;         GetMimeTypeFromExtension,'__GetMimeTypeFromExtension'
end data

data resource
  directory RT_VERSION,versions

  resource versions,\
           1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
              'FileDescription',"HTTP plugin for TV's server x64",\
              'LegalCopyright',<'Tycho Veltmeijer Copyright ',0A9h,' 2014.'>,\
              'FileVersion',"3.00.00.01",\
              'ProductVersion',"3.00.00"
end data

section '.reloc' fixups data readable discardable