
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

include 'win32w.inc'

;32 BIT Equ's
ClearSpaceForAPI     equ 0
UsedSizeBydEnter     equ 0x14
FunctionReturnFactor equ 0x4
scasp equ scasd
movsp equ movsd
jpcxz equ jecxz

psize	    equ 4
pointer     equ dd
pdword	    equ dword
peax	    equ eax
pecx	    equ ecx
pebx	    equ ebx
pedx	    equ edx
pedi	    equ edi
pesi	    equ esi
pebp	    equ ebp
pesp	    equ esp

;nonvolatile values
nvecx	    equ ecx
nvedx	    equ edx

;nonvolatile values
nvecxd	     equ ecx
nvedxd	     equ edx

macro initLinux
{common
}


;With this you can use the macro 'if used is32'
virtual at 0
call is32
is32:
end virtual

virtual at 0
call isWin
isWin:
end virtual

macro StartProc num
{ common
}

macro EndProc num
{ common
}

macro argpush num,arg
{ common
  push arg
}

macro argpop num,arg
{ common
  pop arg
}

macro ClearStack
{ common

}

macro MakeStack
{ common

}

macro fixStack pushAnnyway
{ common
}

macro undoFixStack
{ common
}

if used denter
	denter:
	pop eax
	push edi
	push esi
	push ebx
	push edx
	push ecx
	push ebp

	mov ebp,esp
	add ebp,0x14
	jmp eax

end if

if used dleave
	dleave:
	pop ecx
	mov esp,ebp
	sub esp,0x14
	push ecx
	add esp,0x4
	pop ebp
	pop ecx
	pop edx
	pop ebx
	pop esi
	pop edi
	jmp dword [esp-0x1C]
end if

if used saveVolatileRegister
macro saveVolatileRegister {
    push ecx
    push edx
}
end if

if used restoreVolatileRegister
macro restoreVolatileRegister {
    pop edx
    pop ecx
}
end if

macro lodsp {
   lodsd
}

stosp equ stosd
;macro stosp {
;   stosd
;}
